/**
 * Constantes
 */
const DEBUG = false;

const RUNTIME = 'runtime';
const VERSION = "201128-165144";
const CACHE_CORE = "cache_core-v_201128-165144";
const CACHE_FONTS = "cache_fonts-v_201128-165144";
const CACHE_ATTACHMENTS = "cache_attachments-v_201128-165144";
const CACHE_IMAGES = "cache_images-v_201128-165144";
const CACHE_VIDEOS = "cache_videos-v_201128-165144";
const CURRENT_CACHES = [CACHE_CORE, CACHE_FONTS, CACHE_ATTACHMENTS, CACHE_IMAGES, CACHE_VIDEOS];

const CACHE_CORE_URLS = ["./","activiteapprentissage_generalites.html","activiteapprentissage_generalites_1.html","activiteeval.html","activiteeval_1.html","activiteeval_2.html","activiteeval_3.html","activiteeval_4.html","categ1.html","categ1_1.html","court.html","court_1.html","grai_da_pccom.html","grai_minuterie_vv.html","grai_sa_pc.html","grai_telerupteur_pcspecial.html","index.html","lib-md/s_assmnt.js","lib-md/s_scSearch/scSearch.js","lib-md/w_mathjax/mathjaxMgr.js","lib-md/w_mediaelement/mediaelement.min.js","lib-md/w_outMgr/outMgr.js","lib-md/w_panel/panelMgr.js","lib-md/w_plainRange/plainRange.css","lib-md/w_plainRange/plainRange.js","lib-md/w_scCodeMgr/scCodeMgr.css","lib-md/w_scCodeMgr/scCodeMgr.js","lib-md/w_scImageMgr/scImageMgr.js","lib-md/w_searchMgr/searchMgr.js","lib-md/w_teMgr/fullscreen-api-polyfill.min.js","lib-md/w_teMgr/teMgr.js","lib-md/w_teMgr/teSubControllers.js","lib-md/w_teMgr/vtt.min.js","lib-md/w_tePlayer/TESettingsFromTracks.js","lib-md/w_tePlayer/tePlayer.css","lib-md/w_tePlayer/tePlayer.js","lib-md/w_tplMgr/tplMgr.js","lib-md/w_vttTranscript/vttTranscriptMgr.js","lib-sc/scAssmntMgr.js","lib-sc/scCoLib.js","lib-sc/scDragMgr.js","lib-sc/scDynUiMgr.js","lib-sc/scMapMgr.js","lib-sc/scPaLib.js","lib-sc/scSiLib.js","lib-sc/scTiLib.js","lib-sc/scTooltipMgr.js","manifest.json","meta/~Traces.xml","module_VILLA_CHATEAU_-_MONTAGES_SIMPLES.html","module_VILLA_CHATEAU_-_MONTAGES_SIMPLES.txt","norme.html","norme_1.html","ord1.html","ord1_1.html","skin/css/main.css","skin/css/print.css","skin/css/skin.css","skin/img/favicon.ico","skin/js/skin.js","skin/player/flv.txt","skin/player/mp3.txt","skin/player/mp4.txt","tatNorme.html","tatNorme_1.html"];
const CACHE_FONTS_URLS = ["skin/font/fontello.eot","skin/font/fontello.ttf","skin/font/fontello.woff","skin/font/fontello.woff2"];
const CACHE_ATTACHMENTS_URLS = [];
const CACHE_IMAGES_URLS = ["defaultIcons/icon192.png","defaultIcons/icon512.png","lib-md/w_tePlayer/icons.svg","lib-sc/assmntDhtmlTransf/empty.gif","lib-sc/assmntDhtmlTransf/select.gif","res/image_DA.png","res/image_SA.png","res/image_VV.png","res/image_telerupteur.png","res/image_telerupteur_lexman.png","res/image_telerupteur_lexman_1.png","res/image_villa_r1.png","res/image_villa_r1_1.png","res/image_villa_rdc.png","res/image_villa_rdc_1.png","res/imageattention.png","res/imageminuterie1.png","res/imageminuterie1_1.png","res/imageminuterie2.png","res/imageminuterie2_1.png","res/imageminuterie_important.png","res/imageminuterie_important_1.png","res/imagevilla.png","res/imagevilla_1.png","skin/font/fontello.svg","skin/img/code/buttons.png","skin/img/content/blocks.svg","skin/img/content/buttons.svg","skin/img/content/ico.svg","skin/img/content/loader.svg","skin/img/lic/by-nc-nd.png","skin/img/lic/by-nc-sa.png","skin/img/lic/by-nc.png","skin/img/lic/by-nd.png","skin/img/lic/by-sa.png","skin/img/lic/by.png","skin/img/lic/gnu-fdl.png","skin/img/lic/publicdomain.png","skin/img/lic/zero.png","skin/img/quiz/drag.svg","skin/img/quiz/drop.svg","skin/img/quiz/eval.svg","skin/img/quiz/explain.png","skin/img/quiz/practClose.png","skin/img/quiz/practOpen.png","skin/img/quiz/quest.png","skin/img/quiz/score.png","skin/img/quiz/sol.png","skin/img/richStream/icons.svg","skin/img/richStream/videoPlayPause.svg","skin/img/search/find.svg","skin/img/search/schBtn.svg","skin/img/search/schMnuTgle.svg","skin/img/search/schPgeRank.svg","skin/img/tpl/back-bottom-straight.svg","skin/img/tpl/back-bottom.svg","skin/img/tpl/back-home.svg","skin/img/tpl/back-menu.svg","skin/img/tpl/back-top-straight.svg","skin/img/tpl/back-top.svg","skin/img/tpl/button-exit.svg","skin/img/tpl/button-resume.svg","skin/img/tpl/button-start.svg","skin/img/tpl/buttons.svg","skin/img/tpl/menu-bullet-default.svg","skin/img/tpl/menu-bullet-quiz.svg","skin/img/tpl/menu-scroller.svg","skin/img/tpl/menu-toggle.svg","skin/img/tpl/menu-tools.svg","skin/img/tpl/mnuEmeraude.svg","skin/img/tpl/mnuMobile.svg","skin/img/tpl/scBtn.png","skin/img/tpl/toolbar-quiz.svg"];
const CACHE_VIDEOS_URLS = [];
const CURRENT_CACHES_URLS = [CACHE_CORE_URLS, CACHE_FONTS_URLS, CACHE_ATTACHMENTS_URLS, CACHE_IMAGES_URLS, CACHE_VIDEOS_URLS];

/**
 * Installe le service worker, création de caches et enregistrement des fichiers
 */
self.addEventListener('install', (event) => event.waitUntil(installSW()));
async function installSW() {
    log('L\'installation du Service Worker a démarré');
    CURRENT_CACHES.forEach(async (cacheName, index) => {
        if (!cacheName.includes('no_cache')) {
            const cache = await caches.open(cacheName);            
            await cache.addAll(CURRENT_CACHES_URLS[index]);
            return self.skipWaiting();
        }
    });
}

/**
 * Active le service worker. Lors de la mise à jour, ne supprime que les caches qui seront mis à jour (pas de no_cach dans le cachename)
 */
self.addEventListener('activate', () => activateSW());
async function activateSW() {
    log('Service Worker activé');
    const currentCaches = [RUNTIME].concat(CURRENT_CACHES);
    const cacheKeys = await caches.keys();
    cacheKeys.forEach((cacheKey) => {
        if (!currentCaches.includes(cacheKey) && currentCaches.some((cacheName) => cacheKey.includes(cacheName.split('-')[0]) && cacheName.split('-')[1] !== 'no_cache')) {
            caches.delete(cacheKey);
        }
    });
    showNotification('Application activée et mise à jour', { body: 'L\'application a été mise à jour! Veuillez rafraîchir la page.' });
    log('Le cache a été mis à jour! Veuillez rafraichir la page.');
}
  
/**
 * Renvoie les fichiers mis en cache. S'ils n'existent pas les met dans cache Runtime et les utilise
 */
self.addEventListener('fetch', (event) => event.respondWith(cacheThenNetwork(event)));
async function cacheThenNetwork(event) {
    const cachedResponse = await caches.match(event.request);
    if (cachedResponse) {
        log('Cache : ' + event.request.url);
        return cachedResponse;
    }
    const runtimeCache = await caches.open(RUNTIME);
    const networkResponse = await fetch(event.request, { credentials: 'include', mode: 'no-cors' });
    await runtimeCache.put(event.request, networkResponse.clone())
    log('RUNTIME cache : ' + event.request.url);
    return networkResponse;
}

/**
 * Permet de faire des notifications via Push API (cf. https://developers.google.com/web/fundamentals/push-notifications/) -> use https://web-push-codelab.glitch.me/
 * Le message doit etre de la forme : {title: string, body?:string, data: {url?:string}}
 * La clé de souscription est à récupérer dans la console elle est de forme : {"endpoint":"https://fcm.googleapis.com/fcm/send/dEIKoAKX9zM:APA91b......euXl4nU-tiRgbvQVFP4LYWxt50CUXQ3G9I1W4ePP0ya0Eed2V5SYEgi_Y","auth":"COxpEPSjPvegukrrvjo9jw"}}
 */
self.addEventListener('push', (event) => {
    const dataJSON = event.data.json();
    const notificationOptions = {
        body: dataJSON.body,
        data: {
            url: dataJSON.url,
        }
    };
    return showNotification(dataJSON.title, notificationOptions);
});
self.addEventListener('notificationclick', (event) => {
    const url =  event.notification.data && event.notification.data.url;    
    if (url) {
        event.notification.close();
        event.waitUntil(clients.openWindow(url));
    }
});


/**
 * log si debug à true
 */
function log(message, ...data) {
    if (DEBUG) {
        if (data.length > 0) console.log(VERSION, message, data);
        else console.log(VERSION, message);
    }
}

/**
 * Affiche une notification locale simple
 */
function showNotification(title, datas = {}) {
    if (Notification.permission === "granted") {
        datas.icon = "";
        self.registration.showNotification(title, datas);
    }
}